import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import java.net.*;
import java.nio.charset.*;
import java.nio.file.*;
import java.util.*;
import javax.imageio.*;
import javax.swing.*;

//-------------------------------------
class ImgMkr extends JFrame {

static ImgMkr mf;

CDA     cnvs;
JButton sbar;

//-------------------------------------
BufferedImage img;
File          fil;
Font          uif;
int           cnvx, cnvy, maxx, maxy, winx, winy, wxp, wyp;
int           imgx, imgy, uifs;
String        fc, fn, stxt, uifn, wdir;

//-------------------------------------
static final int UIFS   = 32;
static final int WXP    = 50;
static final int WYP    = 50;
static final String UIFN = "Sans";
static final String UIFNLIT = "UIFN";
static final String UIFSLIT = "UIFS";
static final String WXPLIT = "WXP";
static final String WYPLIT = "WYP";
static final String IMGXLIT = "IMGX";
static final String IMGYLIT = "IMGY";

//-------------------------------------
class AMinimize implements ActionListener {
public void actionPerformed(ActionEvent qae) {
  mf.setState(Frame.ICONIFIED);
}}

//-------------------------------------
class AOpen implements ActionListener {
public void actionPerformed(ActionEvent ae) {
Graphics     g;
Graphics2D   g2;
int          fsts;
JFileChooser jfc;
Rectangle    r;
  jfc = new JFileChooser(wdir);
  jfc.setPreferredSize(new Dimension((maxx*80)/100, (maxy*90)/100));
  fsts = jfc.showOpenDialog(mf);
  if (fsts == JFileChooser.APPROVE_OPTION) {
    g = img.getGraphics();  
    g2 = (Graphics2D)g;
    g2.setStroke(new BasicStroke(4));
    fil = jfc.getSelectedFile();
    wdir = fil.getPath();
    fn = fil.getName();
    mf.setTitle(fn);
    fc = Util.ReadTextFile(fil, mf);
    r = new Rectangle(cnvx, cnvy);
    ParseFile(fc, g, r);
    g.dispose();
    cnvs.img = img;
    cnvs.repaint(new Rectangle(cnvx, cnvy));
  }
}}

//-------------------------------------
public void AppQuit() {
  System.exit(0);
}

//-------------------------------------
class AQuit implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  AppQuit();
}}

//-------------------------------------
class ASave implements ActionListener {
public void actionPerformed(ActionEvent ae) {
BufferedImage simg;
File          fil;
Graphics      g;
int           fsts, lidx;
JFileChooser  jfc;
Rectangle     r;
String        ext, fn;
  imgx = Util.GetIntValue("imgx", imgx, mf);
  if (imgx==-1) return;
  imgy = Util.GetIntValue("imgy", imgy, mf);
  if (imgy==-1) return;
  jfc = new JFileChooser();
  jfc.setPreferredSize(new Dimension((maxx*80)/100, (maxy*90)/100));
  fsts = jfc.showSaveDialog(mf);
  if (fsts == JFileChooser.APPROVE_OPTION) {
    fil = jfc.getSelectedFile();
    fn = fil.getName();
    lidx = fn.lastIndexOf('.');
    ext = fn.substring(lidx+1, fn.length());
    r = new Rectangle(imgx, imgy);
    simg = new BufferedImage(imgx, imgy, BufferedImage.TYPE_INT_RGB);
    g = simg.getGraphics();  
    ParseFile(fc, g, r);
    g.dispose();
    try {
      ImageIO.write(simg, ext, fil);
    } catch(Exception e) { Util.DspMsg(e.toString(), mf); }
  }
}}

//-------------------------------------
class ASize implements ActionListener {
public void actionPerformed(ActionEvent ae) {
int px, py;
  px = Util.GetIntValue("x", imgx, mf);
  if (px==-1) return;
  py = Util.GetIntValue("y", imgy, mf);
  if (py==-1) return;
  mf.setSize(px, py+sbar.getHeight());
}}

//-------------------------------------
class CBButton implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  PopupMain();
}}

//-------------------------------------
class CBKey extends KeyAdapter {
public void keyPressed(KeyEvent ke) {
  if (ke.getKeyCode() == KeyEvent.VK_F1) PopupMain();
  if (ke.getKeyCode() == KeyEvent.VK_Q) AppQuit();
}}

//-------------------------------------
class CBResize extends ComponentAdapter {
public void componentResized(ComponentEvent ce) {
  cnvy = cnvs.getHeight();
  cnvx = cnvs.getWidth();
  img = new BufferedImage(cnvx, cnvy, BufferedImage.TYPE_INT_RGB);
}}

//-------------------------------------
public ImgMkr(String[] args) {
Dimension dim;
Toolkit   tk;
  tk = Toolkit.getDefaultToolkit();
  dim = tk.getScreenSize();
  maxx = dim.width;
  maxy = dim.height;
}

//-------------------------------------
public void Initlz() {
  InitlzData();
  ReadIniFile();
  InitlzUI();
  LayoutUI();
}

//-------------------------------------
public void InitlzData() {
  uifs = UIFS;
  uifn = UIFN;
  wxp = WXP;
  wyp = WYP;
  stxt = "Click Here";
}

//-------------------------------------
public void InitlzUI() {
Font f;
  winx = (maxx*wxp)/100;
  winy = (maxy*wyp)/100;
  uif = new Font(uifn, Font.BOLD, uifs);
  f = new Font(uifn, Font.BOLD, uifs/2);
  Util.PutUIManFonts(f);
  cnvs = new CDA();
  cnvs.setBackground(new Color(32, 255, 32));
  cnvs.addKeyListener(new CBKey());
  cnvs.addComponentListener(new CBResize());
  sbar = new JButton(stxt);
  sbar.setFont(uif);
  sbar.addActionListener(new CBButton());
  sbar.setBackground(new Color(16, 16, 128));
  sbar.setForeground(new Color(255, 255, 0));
}

//-------------------------------------
public void LayoutUI() {
Image     iimg;
Toolkit   tk;
URL       iurl;
  mf.addKeyListener(new CBKey());
  mf.setSize(winx, winy);
  mf.getContentPane().add(sbar, BorderLayout.NORTH);
  mf.getContentPane().add(cnvs, BorderLayout.CENTER);
  mf.setTitle("ImgMkr");
  mf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
  mf.setVisible(true);
  iurl = this.getClass().getResource("/ImgMkr.png");
  tk = Toolkit.getDefaultToolkit();
  iimg = tk.createImage(iurl);
  mf.setIconImage(iimg);
}

//-------------------------------------
public static void main(String[] args) {
  System.out.println("starting ImgMkr\n");
  mf = new ImgMkr(args);
  mf.Initlz();
}

//-------------------------------------
public void ParseFile(String fc, Graphics g, Rectangle br) {
int      i, ne;
String[] tkns;
  tkns = fc.split("\n");
  ne = tkns.length;
  for (i=0; i<ne; i++) ParseFileLine(tkns[i], g, br);
}

//-------------------------------------
public void ParseFileLine(String lin, Graphics g, Rectangle br) {
String[] tkns;
  tkns = lin.split(" ");
  if (tkns[0].equalsIgnoreCase("Arc")) RenderArc(g, tkns, br);
  if (tkns[0].equalsIgnoreCase("Color")) RenderColor(g, tkns, br);
  if (tkns[0].equalsIgnoreCase("Font")) RenderFont(g, tkns, br);
  if (tkns[0].equalsIgnoreCase("FontB")) RenderFontB(g, tkns, br);
  if (tkns[0].equalsIgnoreCase("FontI")) RenderFontI(g, tkns, br);
  if (tkns[0].equalsIgnoreCase("File")) RenderFile(g, tkns, br);
  if (tkns[0].equalsIgnoreCase("Line")) RenderLine(g, tkns, br);
  if (tkns[0].equalsIgnoreCase("Oval")) RenderOval(g, tkns, br);
  if (tkns[0].equalsIgnoreCase("Rect")) RenderRect(g, tkns, br);
  if (tkns[0].equalsIgnoreCase("RRect")) RenderRoundRect(g, tkns, br);
  if (tkns[0].equalsIgnoreCase("Stroke")) RenderStroke(g, tkns, br);
  if (tkns[0].equalsIgnoreCase("Text")) RenderText(g, tkns, br);
}

//-------------------------------------
public void PopupMain() {
JMenuItem     mi;
JPopupMenu    pum;
  pum = new JPopupMenu();
  mi = new JMenuItem("Open");
  mi.setMnemonic('O');
  mi.addActionListener(new AOpen());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("SaveImage");
  mi.setMnemonic('S');
  mi.addActionListener(new ASave());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("siZe");
  mi.setMnemonic('Z');
  mi.addActionListener(new ASize());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Minimize");
  mi.setMnemonic('M');
  mi.addActionListener(new AMinimize());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Quit");
  mi.setMnemonic('Q');
  mi.addActionListener(new AQuit());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(sbar, 0, 0);
}

//-------------------------------------
public void ReadIniFile() {
BufferedReader  br;
Charset         cs;
File            inif;
Path            ifp;
String          jini, line, nam, val;
String[]        sa;
  jini = System.getenv("JINI")+"ImgMkr.ini";
  inif = new File(jini);
  if (!inif.exists()) {
    stxt = "no ini file";
    return;
  }
  ifp = inif.toPath();
  cs = Charset.forName("US-ASCII");
  try {
    br = Files.newBufferedReader(ifp, cs);
    while ((line = br.readLine()) != null) {
      sa = line.split("=");
      if (sa.length==2) {
        nam = sa[0];
        val = sa[1];
        if (nam.compareTo(UIFNLIT)==0) uifn = val;
        if (nam.compareTo(UIFSLIT)==0) uifs = Integer.parseInt(val);
        if (nam.compareTo(WXPLIT)==0) wxp = Integer.parseInt(val);
        if (nam.compareTo(WYPLIT)==0) wyp = Integer.parseInt(val);
        if (nam.compareTo(IMGXLIT)==0) imgx = Integer.parseInt(val);
        if (nam.compareTo(IMGYLIT)==0) imgy = Integer.parseInt(val);
      }
    }
  } catch (Exception x) { System.err.format("Exception: %s%n", x); }
}

//-------------------------------------
public void RenderArc(Graphics g, String[] tkns, Rectangle br) {
int aa, bx, by, fill, sa, x, y;
  if (tkns.length!=8) return;
  bx = (int)((br.getWidth()*Float.valueOf(tkns[1]))+br.getX());
  by = (int)((br.getHeight()*Float.valueOf(tkns[2]))+br.getY());
  x = (int)(br.getWidth()*Float.valueOf(tkns[3]));
  y = (int)(br.getHeight()*Float.valueOf(tkns[4]));
  sa = Integer.valueOf(tkns[5]);
  aa = Integer.valueOf(tkns[6]);
  fill = Integer.valueOf(tkns[7]);
  if (fill>0) g.fillArc(bx, by, x, y, sa, aa);
  else g.drawArc(bx, by, x, y, sa, aa);
}

//-------------------------------------
public void RenderColor(Graphics g, String[] tkns, Rectangle br) {
Color clr;
float ac, bc, gc, rc;
  if (tkns.length!=5) return;
  rc = Float.valueOf(tkns[1]);
  gc = Float.valueOf(tkns[2]);
  bc = Float.valueOf(tkns[3]);
  ac = Float.valueOf(tkns[4]);
  clr = new Color(rc, gc, bc, ac);
  g.setColor(clr);
}

//-------------------------------------
public void RenderFile(Graphics g, String[] tkns, Rectangle br) {
int       brbx, brby, brx, bry, i, ne;
Path      pth;
Rectangle nbr;
String    fnam, nfc;
  if (tkns.length<6) return;
  brbx = (int)((br.getWidth()*Float.valueOf(tkns[1]))+br.getX());
  brby = (int)((br.getHeight()*Float.valueOf(tkns[2]))+br.getY());
  brx = (int)(br.getWidth()*Float.valueOf(tkns[3]));
  bry = (int)(br.getHeight()*Float.valueOf(tkns[4]));
  nbr = new Rectangle(brbx, brby, brx, bry);
  fnam = tkns[5];
  ne = tkns.length;
  for (i=6; i<ne; i++) {
    fnam += " ";
    fnam += tkns[i];
  }
  try {
    pth = Path.of(fnam);
    nfc = Files.readString(pth);
    ParseFile(nfc, g, nbr);
  } catch (Exception x) { System.err.format("Exception: %s%n", x); }
}

//-------------------------------------
public void RenderFont(Graphics g, String[] tkns, Rectangle br) {
int    fs, i, ne;
String fn;
  if (tkns.length<3) return;
  fs = (int)(br.getHeight()*Float.valueOf(tkns[1]));
  fn = tkns[2];
  ne = tkns.length;
  for (i=3; i<ne; i++) {
    fn += " ";
    fn += tkns[i];
  }
  g.setFont(new Font(fn, Font.PLAIN, fs));
}

//-------------------------------------
public void RenderFontB(Graphics g, String[] tkns, Rectangle br) {
int    fs, i, ne;
String fn;
  if (tkns.length<3) return;
  fs = (int)(br.getHeight()*Float.valueOf(tkns[1]));
  fn = tkns[2];
  ne = tkns.length;
  for (i=3; i<ne; i++) {
    fn += " ";
    fn += tkns[i];
  }
  g.setFont(new Font(fn, Font.BOLD, fs));
}

//-------------------------------------
public void RenderFontI(Graphics g, String[] tkns, Rectangle br) {
int    fs, i, ne;
String fn;
  if (tkns.length<3) return;
  fs = (int)(br.getHeight()*Float.valueOf(tkns[1]));
  fn = tkns[2];
  ne = tkns.length;
  for (i=3; i<ne; i++) {
    fn += " ";
    fn += tkns[i];
  }
  g.setFont(new Font(fn, Font.ITALIC, fs));
}

//-------------------------------------
public void RenderLine(Graphics g, String[] tkns, Rectangle br) {
int x1, x2, y1, y2;
  if (tkns.length!=5) return;
  x1 = (int)((br.getWidth()*Float.valueOf(tkns[1]))+br.getX());
  y1 = (int)((br.getHeight()*Float.valueOf(tkns[2]))+br.getY());
  x2 = (int)((br.getWidth()*Float.valueOf(tkns[3]))+br.getX());
  y2 = (int)((br.getHeight()*Float.valueOf(tkns[4]))+br.getY());
  g.drawLine(x1, y1, x2, y2);
}

//-------------------------------------
public void RenderOval(Graphics g, String[] tkns, Rectangle br) {
int bx, by, fill, x, y;
  if (tkns.length!=6) return;
  bx = (int)((br.getWidth()*Float.valueOf(tkns[1]))+br.getX());
  by = (int)((br.getHeight()*Float.valueOf(tkns[2]))+br.getY());
  x = (int)(br.getWidth()*Float.valueOf(tkns[3]));
  y = (int)(br.getHeight()*Float.valueOf(tkns[4]));
  fill = Integer.valueOf(tkns[5]);
  if (fill>0) g.fillOval(bx, by, x, y);
  else g.drawOval(bx, by, x, y);
}

//-------------------------------------
public void RenderRect(Graphics g, String[] tkns, Rectangle br) {
int bx, by, fill, x, y;
  if (tkns.length!=6) return;
  bx = (int)((br.getWidth()*Float.valueOf(tkns[1]))+br.getX());
  by = (int)((br.getHeight()*Float.valueOf(tkns[2]))+br.getY());
  x = (int)(br.getWidth()*Float.valueOf(tkns[3]));
  y = (int)(br.getHeight()*Float.valueOf(tkns[4]));
  fill = Integer.valueOf(tkns[5]);
  if (fill>0) g.fillRect(bx, by, x, y);
  else g.drawRect(bx, by, x, y);
}

//-------------------------------------
public void RenderRoundRect(Graphics g, String[] tkns, Rectangle br) {
int ah, aw, bx, by, fill, x, y;
  if (tkns.length!=8) return;
  bx = (int)((br.getWidth()*Float.valueOf(tkns[1]))+br.getX());
  by = (int)((br.getHeight()*Float.valueOf(tkns[2]))+br.getY());
  x = (int)(br.getWidth()*Float.valueOf(tkns[3]));
  y = (int)(br.getHeight()*Float.valueOf(tkns[4]));
  aw = (int)(br.getWidth()*Float.valueOf(tkns[5]));
  ah = (int)(br.getHeight()*Float.valueOf(tkns[6]));
  fill = Integer.valueOf(tkns[7]);
  if (fill>0) g.fillRoundRect(bx, by, x, y, aw, ah);
  else g.drawRoundRect(bx, by, x, y, aw, ah);
}

//-------------------------------------
public void RenderStroke(Graphics g, String[] tkns, Rectangle br) {
float      nss;
Graphics2D g2;
  if (tkns.length!=2) return;
  nss = Float.valueOf(tkns[1])*(int)br.getWidth();
  g2 = (Graphics2D)g;
  g2.setStroke(new BasicStroke(nss));
}

//-------------------------------------
public void RenderText(Graphics g, String[] tkns, Rectangle br) {
FontMetrics fm;
int         bgnx, bgny, bx, by, wid, x, y;
int         i, ne;
String      txt;
  if (tkns.length<6) return;
  bgnx = (int)((br.getWidth()*Float.valueOf(tkns[1]))+br.getX());
  bgny = (int)((br.getHeight()*Float.valueOf(tkns[2]))+br.getY());
  x = (int)(br.getWidth()*Float.valueOf(tkns[3]));
  y = (int)(br.getHeight()*Float.valueOf(tkns[4]));
  txt = tkns[5];
  ne = tkns.length;
  for (i=6; i<ne; i++) {
    txt += " ";
    txt += tkns[i];
  }
  fm = g.getFontMetrics();
  wid = fm.stringWidth(txt);
  bx = bgnx+((x-wid)/2);
  by = bgny+y-((y-fm.getHeight())/2);
  g.drawString(txt, bx, by);
}

//-------------------------------------
}
